Index: drivers/filesystems/btrfs/btrfs_drv.h
===================================================================
--- drivers/filesystems/btrfs/btrfs_drv.h	(révision 75772)
+++ drivers/filesystems/btrfs/btrfs_drv.h	(copie de travail)
@@ -1098,9 +1460,61 @@
 NTSTATUS pause_balance(device_extension* Vcb, KPROCESSOR_MODE processor_mode);
 NTSTATUS resume_balance(device_extension* Vcb, KPROCESSOR_MODE processor_mode);
 NTSTATUS stop_balance(device_extension* Vcb, KPROCESSOR_MODE processor_mode);
-NTSTATUS look_for_balance_item(device_extension* Vcb);
+NTSTATUS look_for_balance_item(_Requires_lock_held_(_Curr_->tree_lock) device_extension* Vcb);
 NTSTATUS remove_device(device_extension* Vcb, void* data, ULONG length, KPROCESSOR_MODE processor_mode);
 
+_Function_class_(KSTART_ROUTINE)
+#ifdef __REACTOS__
+void NTAPI balance_thread(void* context);
+#else
+void balance_thread(void* context);
+#endif
+
+// in volume.c
+NTSTATUS vol_create(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp);
+NTSTATUS vol_close(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp);
+NTSTATUS vol_read(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp);
+NTSTATUS vol_write(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp);
+NTSTATUS vol_query_information(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp);
+NTSTATUS vol_set_information(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp);
+NTSTATUS vol_query_ea(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp);
+NTSTATUS vol_set_ea(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp);
+NTSTATUS vol_flush_buffers(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp);
+NTSTATUS vol_query_volume_information(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp);
+NTSTATUS vol_set_volume_information(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp);
+NTSTATUS vol_cleanup(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp);
+NTSTATUS vol_directory_control(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp);
+NTSTATUS vol_file_system_control(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp);
+NTSTATUS vol_lock_control(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp);
+NTSTATUS vol_device_control(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp);
+NTSTATUS vol_shutdown(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp);
+NTSTATUS vol_query_security(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp);
+NTSTATUS vol_set_security(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp);
+NTSTATUS vol_power(IN PDEVICE_OBJECT DeviceObject, IN PIRP Irp);
+void add_volume_device(superblock* sb, PDEVICE_OBJECT mountmgr, PUNICODE_STRING devpath, UINT64 length, ULONG disk_num, ULONG part_num);
+NTSTATUS mountmgr_add_drive_letter(PDEVICE_OBJECT mountmgr, PUNICODE_STRING devpath);
+
+_Function_class_(DRIVER_NOTIFICATION_CALLBACK_ROUTINE)
+#ifdef __REACTOS__
+NTSTATUS NTAPI pnp_removal(PVOID NotificationStructure, PVOID Context);
+#else
+NTSTATUS pnp_removal(PVOID NotificationStructure, PVOID Context);
+#endif
+
+// in scrub.c
+NTSTATUS start_scrub(device_extension* Vcb, KPROCESSOR_MODE processor_mode);
+NTSTATUS query_scrub(device_extension* Vcb, KPROCESSOR_MODE processor_mode, void* data, ULONG length);
+NTSTATUS pause_scrub(device_extension* Vcb, KPROCESSOR_MODE processor_mode);
+NTSTATUS resume_scrub(device_extension* Vcb, KPROCESSOR_MODE processor_mode);
+NTSTATUS stop_scrub(device_extension* Vcb, KPROCESSOR_MODE processor_mode);
+
+// in send.c
+NTSTATUS send_subvol(device_extension* Vcb, void* data, ULONG datalen, PFILE_OBJECT FileObject, PIRP Irp);
+NTSTATUS read_send_buffer(device_extension* Vcb, PFILE_OBJECT FileObject, void* data, ULONG datalen, ULONG_PTR* retlen, KPROCESSOR_MODE processor_mode);
+
+// based on function in sys/sysmacros.h
+#define makedev(major, minor) (((minor) & 0xFF) | (((major) & 0xFFF) << 8) | (((UINT64)((minor) & ~0xFF)) << 12) | (((UINT64)((major) & ~0xFFF)) << 32))
+
 #define fast_io_possible(fcb) (!FsRtlAreThereCurrentFileLocks(&fcb->lock) && !fcb->Vcb->readonly ? FastIoIsPossible : FastIoIsQuestionable)
 
 static __inline void print_open_trees(device_extension* Vcb) {
@@ -1119,16 +1533,16 @@
     // make sure we don't accidentally write the cache inodes or pagefile compressed
     if (fcb->subvol->id == BTRFS_ROOT_ROOT || fcb->Header.Flags2 & FSRTL_FLAG2_IS_PAGING_FILE)
         return FALSE;
-    
+
     if (fcb->Vcb->options.compress_force)
         return TRUE;
-    
+
     if (fcb->inode_item.flags & BTRFS_INODE_NOCOMPRESS)
         return FALSE;
-    
+
     if (fcb->inode_item.flags & BTRFS_INODE_COMPRESS || fcb->Vcb->options.compress)
         return TRUE;
-    
+
     return FALSE;
 }
 
@@ -1137,7 +1551,7 @@
 #ifndef __REACTOS__
     __m128i x1, x2;
 #endif
-    
+
 #ifndef __REACTOS__
     if (have_sse2 && ((uintptr_t)buf1 & 0xf) == 0 && ((uintptr_t)buf2 & 0xf) == 0) {
         while (len >= 16) {
@@ -1145,7 +1559,7 @@
             x2 = _mm_load_si128((__m128i*)buf2);
             x1 = _mm_xor_si128(x1, x2);
             _mm_store_si128((__m128i*)buf1, x1);
-            
+
             buf1 += 16;
             buf2 += 16;
             len -= 16;
@@ -1152,7 +1566,7 @@
         }
     }
 #endif
-    
+
     for (j = 0; j < len; j++) {
         *buf1 ^= *buf2;
         buf1++;
@@ -1160,8 +1574,6 @@
     }
 }
 
-#define first_device(Vcb) CONTAINING_RECORD(Vcb->devices.Flink, device, list_entry)
-
 #ifdef DEBUG_FCB_REFCOUNTS
 #ifdef DEBUG_LONG_MESSAGES
 #define increase_fileref_refcount(fileref) {\
@@ -1179,14 +1591,12 @@
 #endif
 
 #ifdef _MSC_VER
-// #define int3 __asm { int 3 }
 #define int3 __debugbreak()
 #else
 #define int3 asm("int3;")
 #endif
 
-// if (Vcb->open_trees > 0) { ERR("open tree count = %i\n", Vcb->open_trees); print_open_trees(Vcb); int3; }
-// else TRACE("open tree count = %i\n", Vcb->open_trees);
+#define hex_digit(c) ((c) <= 9) ? ((c) + '0') : ((c) - 10 + 'a')
 
 // FIXME - find a way to catch unfreed trees again
 
@@ -1246,18 +1656,27 @@
 #define S_IXOTH (S_IXGRP >> 3)
 #endif
 
-// LXSS programs can be distinguished by the fact they have a NULL PEB.
-#ifdef _AMD64_
-    static __inline BOOL called_from_lxss() {
-        UINT8* proc = (UINT8*)PsGetCurrentProcess();
-        ULONG_PTR* peb = (ULONG_PTR*)&proc[0x3f8];
-        
-        return !*peb;
-    }
-#else
-#define called_from_lxss() FALSE
+#ifndef S_ISUID
+#define S_ISUID 0004000
 #endif
 
+#ifndef S_ISGID
+#define S_ISGID 0002000
+#endif
+
+#ifndef S_ISVTX
+#define S_ISVTX 0001000
+#endif
+
+static __inline UINT64 fcb_alloc_size(fcb* fcb) {
+    if (S_ISDIR(fcb->inode_item.st_mode))
+        return 0;
+    else if (fcb->atts & FILE_ATTRIBUTE_SPARSE_FILE)
+        return fcb->inode_item.st_blocks;
+    else
+        return sector_align(fcb->inode_item.st_size, fcb->Vcb->superblock.sector_size);
+}
+
 typedef BOOLEAN (*tPsIsDiskCountersEnabled)();
 
 typedef VOID (*tPsUpdateDiskCounters)(PEPROCESS Process, ULONG64 BytesRead, ULONG64 BytesWritten,
@@ -1269,18 +1688,83 @@
 typedef BOOLEAN (*tCcCopyReadEx)(PFILE_OBJECT FileObject, PLARGE_INTEGER FileOffset, ULONG Length, BOOLEAN Wait,
                                  PVOID Buffer, PIO_STATUS_BLOCK IoStatus, PETHREAD IoIssuerThread);
 
+#ifndef CC_ENABLE_DISK_IO_ACCOUNTING
 #define CC_ENABLE_DISK_IO_ACCOUNTING 0x00000010
+#endif
 
 typedef VOID (*tCcSetAdditionalCacheAttributesEx)(PFILE_OBJECT FileObject, ULONG Flags);
 
+typedef VOID (*tFsRtlUpdateDiskCounters)(ULONG64 BytesRead, ULONG64 BytesWritten);
+
 #ifndef __REACTOS__
+#ifndef _MSC_VER
+
 #undef RtlIsNtDdiVersionAvailable
 
 BOOLEAN RtlIsNtDdiVersionAvailable(ULONG Version);
 
-PEPROCESS PsGetThreadProcess(PETHREAD Thread); // not in mingw
+PEPROCESS PsGetThreadProcess(_In_ PETHREAD Thread); // not in mingw
 #endif
 
+// not in DDK headers - taken from winternl.h
+typedef struct _LDR_DATA_TABLE_ENTRY {
+    PVOID Reserved1[2];
+    LIST_ENTRY InMemoryOrderLinks;
+    PVOID Reserved2[2];
+    PVOID DllBase;
+    PVOID Reserved3[2];
+    UNICODE_STRING FullDllName;
+    BYTE Reserved4[8];
+    PVOID Reserved5[3];
+    union {
+        ULONG CheckSum;
+        PVOID Reserved6;
+    };
+    ULONG TimeDateStamp;
+} LDR_DATA_TABLE_ENTRY,*PLDR_DATA_TABLE_ENTRY;
+
+typedef struct _PEB_LDR_DATA {
+    BYTE Reserved1[8];
+    PVOID Reserved2[3];
+    LIST_ENTRY InMemoryOrderModuleList;
+} PEB_LDR_DATA,*PPEB_LDR_DATA;
+
+typedef struct _RTL_USER_PROCESS_PARAMETERS {
+    BYTE Reserved1[16];
+    PVOID Reserved2[10];
+    UNICODE_STRING ImagePathName;
+    UNICODE_STRING CommandLine;
+} RTL_USER_PROCESS_PARAMETERS,*PRTL_USER_PROCESS_PARAMETERS;
+
+typedef VOID (NTAPI *PPS_POST_PROCESS_INIT_ROUTINE)(VOID);
+
+typedef struct _PEB {
+    BYTE Reserved1[2];
+    BYTE BeingDebugged;
+    BYTE Reserved2[1];
+    PVOID Reserved3[2];
+    PPEB_LDR_DATA Ldr;
+    PRTL_USER_PROCESS_PARAMETERS ProcessParameters;
+    BYTE Reserved4[104];
+    PVOID Reserved5[52];
+    PPS_POST_PROCESS_INIT_ROUTINE PostProcessInitRoutine;
+    BYTE Reserved6[128];
+    PVOID Reserved7[1];
+    ULONG SessionId;
+} PEB,*PPEB;
+
+#ifdef _MSC_VER
+__kernel_entry
+NTSTATUS NTAPI ZwQueryInformationProcess(
+    IN HANDLE ProcessHandle,
+    IN PROCESSINFOCLASS ProcessInformationClass,
+    OUT PVOID ProcessInformation,
+    IN ULONG ProcessInformationLength,
+    OUT PULONG ReturnLength OPTIONAL
+);
+#endif
+#endif
+
 #if defined(__REACTOS__) && (NTDDI_VERSION < NTDDI_WIN7)
 NTSTATUS WINAPI RtlUnicodeToUTF8N(CHAR *utf8_dest, ULONG utf8_bytes_max,
                                   ULONG *utf8_bytes_written,
Index: drivers/filesystems/btrfs/btrfsioctl.h
===================================================================
--- drivers/filesystems/btrfs/btrfsioctl.h	(révision 75772)
+++ drivers/filesystems/btrfs/btrfsioctl.h	(copie de travail)
@@ -3,6 +3,8 @@
 #ifndef BTRFSIOCTL_H_DEFINED
 #define BTRFSIOCTL_H_DEFINED
 
+#include "btrfs.h"
+
 #define FSCTL_BTRFS_GET_FILE_IDS CTL_CODE(FILE_DEVICE_UNKNOWN, 0x829, METHOD_OUT_DIRECT, FILE_ANY_ACCESS)
 #define FSCTL_BTRFS_CREATE_SUBVOL CTL_CODE(FILE_DEVICE_UNKNOWN, 0x82a, METHOD_IN_DIRECT, FILE_ANY_ACCESS)
 #define FSCTL_BTRFS_CREATE_SNAPSHOT CTL_CODE(FILE_DEVICE_UNKNOWN, 0x82b, METHOD_IN_DIRECT, FILE_ANY_ACCESS)
@@ -19,6 +21,22 @@
 #define FSCTL_BTRFS_REMOVE_DEVICE CTL_CODE(FILE_DEVICE_UNKNOWN, 0x836, METHOD_IN_DIRECT, FILE_ANY_ACCESS)
 #define IOCTL_BTRFS_QUERY_FILESYSTEMS CTL_CODE(FILE_DEVICE_UNKNOWN, 0x837, METHOD_OUT_DIRECT, FILE_ANY_ACCESS)
 #define FSCTL_BTRFS_GET_UUID CTL_CODE(FILE_DEVICE_UNKNOWN, 0x838, METHOD_OUT_DIRECT, FILE_ANY_ACCESS)
+#define FSCTL_BTRFS_START_SCRUB CTL_CODE(FILE_DEVICE_UNKNOWN, 0x839, METHOD_OUT_DIRECT, FILE_ANY_ACCESS)
+#define FSCTL_BTRFS_QUERY_SCRUB CTL_CODE(FILE_DEVICE_UNKNOWN, 0x83a, METHOD_OUT_DIRECT, FILE_ANY_ACCESS)
+#define FSCTL_BTRFS_PAUSE_SCRUB CTL_CODE(FILE_DEVICE_UNKNOWN, 0x83b, METHOD_OUT_DIRECT, FILE_ANY_ACCESS)
+#define FSCTL_BTRFS_RESUME_SCRUB CTL_CODE(FILE_DEVICE_UNKNOWN, 0x83c, METHOD_OUT_DIRECT, FILE_ANY_ACCESS)
+#define FSCTL_BTRFS_STOP_SCRUB CTL_CODE(FILE_DEVICE_UNKNOWN, 0x83d, METHOD_OUT_DIRECT, FILE_ANY_ACCESS)
+#define IOCTL_BTRFS_PROBE_VOLUME CTL_CODE(FILE_DEVICE_UNKNOWN, 0x83e, METHOD_OUT_DIRECT, FILE_ANY_ACCESS)
+#define FSCTL_BTRFS_RESET_STATS CTL_CODE(FILE_DEVICE_UNKNOWN, 0x83f, METHOD_IN_DIRECT, FILE_ANY_ACCESS)
+#define FSCTL_BTRFS_MKNOD CTL_CODE(FILE_DEVICE_UNKNOWN, 0x840, METHOD_IN_DIRECT, FILE_ANY_ACCESS)
+#define FSCTL_BTRFS_RECEIVED_SUBVOL CTL_CODE(FILE_DEVICE_UNKNOWN, 0x841, METHOD_IN_DIRECT, FILE_ANY_ACCESS)
+#define FSCTL_BTRFS_GET_XATTRS CTL_CODE(FILE_DEVICE_UNKNOWN, 0x842, METHOD_BUFFERED, FILE_ANY_ACCESS)
+#define FSCTL_BTRFS_SET_XATTR CTL_CODE(FILE_DEVICE_UNKNOWN, 0x843, METHOD_IN_DIRECT, FILE_ANY_ACCESS)
+#define FSCTL_BTRFS_RESERVE_SUBVOL CTL_CODE(FILE_DEVICE_UNKNOWN, 0x844, METHOD_IN_DIRECT, FILE_ANY_ACCESS)
+#define FSCTL_BTRFS_FIND_SUBVOL CTL_CODE(FILE_DEVICE_UNKNOWN, 0x845, METHOD_BUFFERED, FILE_ANY_ACCESS)
+#define FSCTL_BTRFS_SEND_SUBVOL CTL_CODE(FILE_DEVICE_UNKNOWN, 0x846, METHOD_BUFFERED, FILE_ANY_ACCESS)
+#define FSCTL_BTRFS_READ_SEND_BUFFER CTL_CODE(FILE_DEVICE_UNKNOWN, 0x847, METHOD_OUT_DIRECT, FILE_ANY_ACCESS)
+#define FSCTL_BTRFS_RESIZE CTL_CODE(FILE_DEVICE_UNKNOWN, 0x848, METHOD_IN_DIRECT, FILE_ANY_ACCESS)
 
 typedef struct {
     UINT64 subvol;
@@ -28,11 +46,25 @@
 
 typedef struct {
     HANDLE subvol;
-    UINT32 namelen;
+    BOOL readonly;
+    BOOL posix;
+    UINT16 namelen;
     WCHAR name[1];
 } btrfs_create_snapshot;
 
 typedef struct {
+    void* POINTER_32 subvol;
+    BOOL readonly;
+    BOOL posix;
+    UINT16 namelen;
+    WCHAR name[1];
+} btrfs_create_snapshot32;
+
+#define BTRFS_COMPRESSION_ANY   0
+#define BTRFS_COMPRESSION_ZLIB  1
+#define BTRFS_COMPRESSION_LZO   2
+
+typedef struct {
     UINT64 subvol;
     UINT64 inode;
     BOOL top;
@@ -44,6 +76,7 @@
     UINT64 flags;
     UINT32 inline_length;
     UINT64 disk_size[3];
+    UINT8 compression_type;
 } btrfs_inode_info;
 
 typedef struct {
@@ -55,6 +88,8 @@
     BOOL gid_changed;
     UINT32 st_mode;
     BOOL mode_changed;
+    UINT8 compression_type;
+    BOOL compression_type_changed;
 } btrfs_set_inode_info;
 
 typedef struct {
@@ -61,9 +96,12 @@
     UINT32 next_entry;
     UINT64 dev_id;
     UINT64 size;
+    UINT64 max_size;
     BOOL readonly;
+    BOOL missing;
     ULONG device_number;
     ULONG partition_number;
+    UINT64 stats[5];
     USHORT namelen;
     WCHAR name[1];
 } btrfs_device;
@@ -117,6 +155,7 @@
 #define BTRFS_BALANCE_PAUSED    2
 #define BTRFS_BALANCE_REMOVAL   4
 #define BTRFS_BALANCE_ERROR     8
+#define BTRFS_BALANCE_SHRINKING 16
 
 typedef struct {
     UINT32 status;
@@ -134,6 +173,7 @@
 
 typedef struct {
     UINT8 uuid[16];
+    BOOL missing;
     USHORT name_length;
     WCHAR name[1];
 } btrfs_filesystem_device;
@@ -145,4 +185,93 @@
     btrfs_filesystem_device device;
 } btrfs_filesystem;
 
+#define BTRFS_SCRUB_STOPPED     0
+#define BTRFS_SCRUB_RUNNING     1
+#define BTRFS_SCRUB_PAUSED      2
+
+typedef struct {
+    UINT32 next_entry;
+    UINT64 address;
+    UINT64 device;
+    BOOL recovered;
+    BOOL is_metadata;
+    BOOL parity;
+
+    union {
+        struct {
+            UINT64 subvol;
+            UINT64 offset;
+            UINT16 filename_length;
+            WCHAR filename[1];
+        } data;
+
+        struct {
+            UINT64 root;
+            UINT8 level;
+            KEY firstitem;
+        } metadata;
+    };
+} btrfs_scrub_error;
+
+typedef struct {
+    UINT32 status;
+    LARGE_INTEGER start_time;
+    LARGE_INTEGER finish_time;
+    UINT64 chunks_left;
+    UINT64 total_chunks;
+    UINT64 data_scrubbed;
+    UINT64 duration;
+    NTSTATUS error;
+    UINT32 num_errors;
+    btrfs_scrub_error errors;
+} btrfs_query_scrub;
+
+typedef struct {
+    UINT64 inode;
+    UINT8 type;
+    UINT64 st_rdev;
+    UINT16 namelen;
+    WCHAR name[1];
+} btrfs_mknod;
+
+typedef struct {
+    UINT64 generation;
+    BTRFS_UUID uuid;
+} btrfs_received_subvol;
+
+typedef struct {
+    USHORT namelen;
+    USHORT valuelen;
+    char data[1];
+} btrfs_set_xattr;
+
+typedef struct {
+    BOOL readonly;
+    BOOL posix;
+    USHORT namelen;
+    WCHAR name[1];
+} btrfs_create_subvol;
+
+typedef struct {
+    BTRFS_UUID uuid;
+    UINT64 ctransid;
+} btrfs_find_subvol;
+
+typedef struct {
+    HANDLE parent;
+    ULONG num_clones;
+    HANDLE clones[1];
+} btrfs_send_subvol;
+
+typedef struct {
+    void* POINTER_32 parent;
+    ULONG num_clones;
+    void* POINTER_32 clones[1];
+} btrfs_send_subvol32;
+
+typedef struct {
+    UINT64 device;
+    UINT64 size;
+} btrfs_resize;
+
 #endif
Index: drivers/filesystems/btrfs/cache.c
===================================================================
--- drivers/filesystems/btrfs/cache.c	(révision 75772)
+++ drivers/filesystems/btrfs/cache.c	(copie de travail)
@@ -1,34 +1,34 @@
-/* Copyright (c) Mark Harmstone 2016
- * 
+/* Copyright (c) Mark Harmstone 2016-17
+ *
  * This file is part of WinBtrfs.
- * 
+ *
  * WinBtrfs is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Lesser General Public Licence as published by
  * the Free Software Foundation, either version 3 of the Licence, or
  * (at your option) any later version.
- * 
+ *
  * WinBtrfs is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU Lesser General Public Licence for more details.
- * 
+ *
  * You should have received a copy of the GNU Lesser General Public Licence
  * along with WinBtrfs.  If not, see <http://www.gnu.org/licenses/>. */
 
 #include "btrfs_drv.h"
-#include <wdm.h>
 
 CACHE_MANAGER_CALLBACKS* cache_callbacks;
 
-static BOOLEAN STDCALL acquire_for_lazy_write(PVOID Context, BOOLEAN Wait) {
+#ifdef __REACTOS__
+static BOOLEAN NTAPI acquire_for_lazy_write(PVOID Context, BOOLEAN Wait) {
+#else
+static BOOLEAN acquire_for_lazy_write(PVOID Context, BOOLEAN Wait) {
+#endif
     PFILE_OBJECT FileObject = Context;
     fcb* fcb = FileObject->FsContext;
-    
+
     TRACE("(%p, %u)\n", Context, Wait);
-    
-//     if (!fcb || FileObject->Flags & FO_CLEANUP_COMPLETE)
-//         return FALSE;
-    
+
     if (!ExAcquireResourceSharedLite(&fcb->Vcb->tree_lock, Wait))
         return FALSE;
 
@@ -36,53 +36,83 @@
         ExReleaseResourceLite(&fcb->Vcb->tree_lock);
         return FALSE;
     }
-    
+
     fcb->lazy_writer_thread = KeGetCurrentThread();
-    
+
+    IoSetTopLevelIrp((PIRP)FSRTL_CACHE_TOP_LEVEL_IRP);
+
     return TRUE;
 }
 
-static void STDCALL release_from_lazy_write(PVOID Context) {
+#ifdef __REACTOS__
+static void NTAPI release_from_lazy_write(PVOID Context) {
+#else
+static void release_from_lazy_write(PVOID Context) {
+#endif
     PFILE_OBJECT FileObject = Context;
     fcb* fcb = FileObject->FsContext;
-    
+
     TRACE("(%p)\n", Context);
-    
-//     if (!fcb || FileObject->Flags & FO_CLEANUP_COMPLETE)
-//         return;
-    
+
     fcb->lazy_writer_thread = NULL;
-    
+
     ExReleaseResourceLite(fcb->Header.Resource);
-    
+
     ExReleaseResourceLite(&fcb->Vcb->tree_lock);
+
+    if (IoGetTopLevelIrp() == (PIRP)FSRTL_CACHE_TOP_LEVEL_IRP)
+        IoSetTopLevelIrp(NULL);
 }
 
-static BOOLEAN STDCALL acquire_for_read_ahead(PVOID Context, BOOLEAN Wait) {
+#ifdef __REACTOS__
+static BOOLEAN NTAPI acquire_for_read_ahead(PVOID Context, BOOLEAN Wait) {
+#else
+static BOOLEAN acquire_for_read_ahead(PVOID Context, BOOLEAN Wait) {
+#endif
+    PFILE_OBJECT FileObject = Context;
+    fcb* fcb = FileObject->FsContext;
+
     TRACE("(%p, %u)\n", Context, Wait);
-    
+
+    if (!ExAcquireResourceSharedLite(fcb->Header.Resource, Wait))
+        return FALSE;
+
+    IoSetTopLevelIrp((PIRP)FSRTL_CACHE_TOP_LEVEL_IRP);
+
     return TRUE;
 }
 
-static void STDCALL release_from_read_ahead(PVOID Context) {
+#ifdef __REACTOS__
+static void NTAPI release_from_read_ahead(PVOID Context) {
+#else
+static void release_from_read_ahead(PVOID Context) {
+#endif
+    PFILE_OBJECT FileObject = Context;
+    fcb* fcb = FileObject->FsContext;
+
     TRACE("(%p)\n", Context);
+
+    ExReleaseResourceLite(fcb->Header.Resource);
+
+    if (IoGetTopLevelIrp() == (PIRP)FSRTL_CACHE_TOP_LEVEL_IRP)
+        IoSetTopLevelIrp(NULL);
 }
 
-NTSTATUS STDCALL init_cache() {
+NTSTATUS init_cache() {
     cache_callbacks = ExAllocatePoolWithTag(NonPagedPool, sizeof(CACHE_MANAGER_CALLBACKS), ALLOC_TAG);
     if (!cache_callbacks) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     cache_callbacks->AcquireForLazyWrite = acquire_for_lazy_write;
     cache_callbacks->ReleaseFromLazyWrite = release_from_lazy_write;
     cache_callbacks->AcquireForReadAhead = acquire_for_read_ahead;
     cache_callbacks->ReleaseFromReadAhead = release_from_read_ahead;
-    
+
     return STATUS_SUCCESS;
 }
 
-void STDCALL free_cache() {
+void free_cache() {
     ExFreePool(cache_callbacks);
 }
Index: drivers/filesystems/btrfs/calcthread.c
===================================================================
--- drivers/filesystems/btrfs/calcthread.c	(révision 75772)
+++ drivers/filesystems/btrfs/calcthread.c	(copie de travail)
@@ -1,17 +1,17 @@
-/* Copyright (c) Mark Harmstone 2016
- * 
+/* Copyright (c) Mark Harmstone 2016-17
+ *
  * This file is part of WinBtrfs.
- * 
+ *
  * WinBtrfs is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Lesser General Public Licence as published by
  * the Free Software Foundation, either version 3 of the Licence, or
  * (at your option) any later version.
- * 
+ *
  * WinBtrfs is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU Lesser General Public Licence for more details.
- * 
+ *
  * You should have received a copy of the GNU Lesser General Public Licence
  * along with WinBtrfs.  If not, see <http://www.gnu.org/licenses/>. */
 
@@ -21,13 +21,13 @@
 
 NTSTATUS add_calc_job(device_extension* Vcb, UINT8* data, UINT32 sectors, UINT32* csum, calc_job** pcj) {
     calc_job* cj;
-    
+
     cj = ExAllocatePoolWithTag(NonPagedPool, sizeof(calc_job), ALLOC_TAG);
     if (!cj) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     cj->data = data;
     cj->sectors = sectors;
     cj->csum = csum;
@@ -39,18 +39,18 @@
     ExAcquireResourceExclusiveLite(&Vcb->calcthreads.lock, TRUE);
     InsertTailList(&Vcb->calcthreads.job_list, &cj->list_entry);
     ExReleaseResourceLite(&Vcb->calcthreads.lock);
-    
+
     KeSetEvent(&Vcb->calcthreads.event, 0, FALSE);
     KeClearEvent(&Vcb->calcthreads.event);
-    
+
     *pcj = cj;
-    
+
     return STATUS_SUCCESS;
 }
 
 void free_calc_job(calc_job* cj) {
     LONG rc = InterlockedDecrement(&cj->refcount);
-    
+
     if (rc == 0)
         ExFreePool(cj);
 }
@@ -60,15 +60,15 @@
     UINT32* csum;
     UINT8* data;
     ULONG blocksize, i;
-    
+
     pos = InterlockedIncrement(&cj->pos) - 1;
-    
-    if (pos * SECTOR_BLOCK >= cj->sectors)
+
+    if ((UINT32)pos * SECTOR_BLOCK >= cj->sectors)
         return FALSE;
 
     csum = &cj->csum[pos * SECTOR_BLOCK];
     data = cj->data + (pos * SECTOR_BLOCK * Vcb->superblock.sector_size);
-    
+
     blocksize = min(SECTOR_BLOCK, cj->sectors - (pos * SECTOR_BLOCK));
     for (i = 0; i < blocksize; i++) {
         *csum = ~calc_crc32c(0xffffffff, data, Vcb->superblock.sector_size);
@@ -75,20 +75,21 @@
         csum++;
         data += Vcb->superblock.sector_size;
     }
-    
+
     done = InterlockedIncrement(&cj->done);
-    
-    if (done * SECTOR_BLOCK >= cj->sectors) {
+
+    if ((UINT32)done * SECTOR_BLOCK >= cj->sectors) {
         ExAcquireResourceExclusiveLite(&Vcb->calcthreads.lock, TRUE);
         RemoveEntryList(&cj->list_entry);
         ExReleaseResourceLite(&Vcb->calcthreads.lock);
-        
+
         KeSetEvent(&cj->event, 0, FALSE);
     }
-    
+
     return TRUE;
 }
 
+_Function_class_(KSTART_ROUTINE)
 #ifdef __REACTOS__
 void NTAPI calc_thread(void* context) {
 #else
@@ -96,47 +97,43 @@
 #endif
     drv_calc_thread* thread = context;
     device_extension* Vcb = thread->DeviceObject->DeviceExtension;
-    
+
     ObReferenceObject(thread->DeviceObject);
-    
+
     while (TRUE) {
         KeWaitForSingleObject(&Vcb->calcthreads.event, Executive, KernelMode, FALSE, NULL);
-        
-        FsRtlEnterFileSystem();
-        
+
         while (TRUE) {
             calc_job* cj;
             BOOL b;
-            
+
             ExAcquireResourceExclusiveLite(&Vcb->calcthreads.lock, TRUE);
-            
+
             if (IsListEmpty(&Vcb->calcthreads.job_list)) {
                 ExReleaseResourceLite(&Vcb->calcthreads.lock);
                 break;
             }
-            
+
             cj = CONTAINING_RECORD(Vcb->calcthreads.job_list.Flink, calc_job, list_entry);
             cj->refcount++;
-            
+
             ExReleaseResourceLite(&Vcb->calcthreads.lock);
-            
+
             b = do_calc(Vcb, cj);
-            
+
             free_calc_job(cj);
-            
+
             if (!b)
                 break;
         }
-        
-        FsRtlExitFileSystem();
-        
+
         if (thread->quit)
             break;
     }
 
     ObDereferenceObject(thread->DeviceObject);
-     
+
     KeSetEvent(&thread->finished, 0, FALSE);
-     
+
     PsTerminateSystemThread(STATUS_SUCCESS);
 }
